using System;
using System.Collections.Generic;
using System.Text;
using InterfaceLibrary;

namespace ModelLibrary
{
    public class Vare : IVare
    {
        private int varenr;
        private string betegnelse;
        private int antalPLager;
        private float salgsEnhedsPris;

        private List<Varebevaegelse> bevgelser = new List<Varebevaegelse>();     // liste til bevgelserne

        private object varels = new object();

        public Vare()       // default constructor  - skal bruges ved nyt registreret remote objekt
        { }

        public Vare(int varenr, string betegnelse, float salgsEnhedsPris)
        {
            this.varenr = varenr;
            this.betegnelse = betegnelse;
            this.salgsEnhedsPris = salgsEnhedsPris;
        }
 
        #region IVare Members

        public int Varenr
        {
            get { return this.varenr; }
        }

        public string Betegnelse
        {
            get
            {
                return this.betegnelse;
            }
            set
            {
                this.betegnelse = value;
            }
        }

        public int AntalPLager
        {
            get { return this.antalPLager; }
        }

        public float SalgsEnhedsPris
        {
            get
            {
                lock(varels)
                    return this.salgsEnhedsPris;
            }
            set
            {
                lock (varels)
                    this.salgsEnhedsPris = value;
            }
        }

        public double Salgsvrdi()
        {
            //lock (varels)
            //    return this.salgsEnhedsPris * this.antalPLager;
            return this.SalgsEnhedsPris * this.AntalPLager;
        }

        public IVarebevaegelse RegistrerVarerSolgt(int antal, int dato, float stykpris)
        {
            lock (varels)
            {
                this.antalPLager -= antal;
                Varebevaegelse nyBevgelse = new Varebevaegelse(antal, dato, stykpris, 1); //1 for salg!
                this.bevgelser.Add(nyBevgelse);
                return nyBevgelse;
            }
        }

        public IVarebevaegelse RegistrerVarerIndkbt(int antal, int dato, float stykpris)
        {
            lock (varels)
            {
                this.antalPLager += antal;
                Varebevaegelse nyBevgelse = new Varebevaegelse(antal, dato, stykpris, 0); //0 for indkb!
                this.bevgelser.Add(nyBevgelse);
                return nyBevgelse;
            }
        }

        public IVarebevaegelse[] GetBevgelser()
        {
            return bevgelser.ToArray();
        }

        #endregion

        public override string ToString()
        {
            return ""+varenr+" ;"+betegnelse+" ;"+antalPLager+" ;"+salgsEnhedsPris.ToString("F2");
        }

    }
}
