using System;
using System.Collections.Generic;
using System.Text;
using InterfaceLibrary;

namespace ModelLibrary
{
    public class VareFacade : MarshalByRefObject
    {
        private IVare aktuelVare;
        
        public VareDTO[] GetAlleVarerUdenBevgelser()            // VareDTO opbygges og returneres for alle varer
        {
            List<VareDTO> varerDTO = new List<VareDTO>();
            IVare[] alleVarer = Model.GetVarekataloget().GetAlleVarer();
            foreach (IVare v in alleVarer)
            {
                varerDTO.Add(new VareDTO(v.Varenr, v.Betegnelse, v.AntalPLager, v.SalgsEnhedsPris));
            }
            return varerDTO.ToArray();
        }

        public bool FindVare(int varenr)                        // skal finde varen og huske den som aktuel p serveren
        {
            aktuelVare = Model.GetVarekataloget().FindVare(varenr);
            if (aktuelVare == null) return false;
            else return true;
        }

        public VareDTO GetAktuelVare()                          // VareDTO opbygges ud serverens aktuelle vare 
        {
            return new VareDTO(aktuelVare.Varenr, aktuelVare.Betegnelse, aktuelVare.AntalPLager, aktuelVare.SalgsEnhedsPris);
        }

        public IVarebevaegelse[] GetAktuelVarebevgelser()      // Bevgelser for serverens aktuelle vare
        {
            return aktuelVare.GetBevgelser();
        }

        public void RegistrerVarerSolgtPAktuelVare(int antal)    // registrer p serverens aktuelle vare
        {
            DateTime dt = DateTime.Now;
            int nuDato = dt.Year * 10000 + dt.Month * 100 + dt.Day;
            aktuelVare.RegistrerVarerSolgt(antal, nuDato, aktuelVare.SalgsEnhedsPris);
        }

        public void RegistrerVarerIndkbtPAktuelVare(int antal)   // registrer p serverens aktuelle vare
        {
            DateTime dt = DateTime.Now;
            int nuDato = dt.Year * 10000 + dt.Month * 100 + dt.Day;
            aktuelVare.RegistrerVarerIndkbt(antal, nuDato, aktuelVare.SalgsEnhedsPris*0.6f);
        }

        public void RetAktuelVare(VareDTO varedata)                // Skal ndre betegnelse og salgsenhedspris ud fra det VareDTO der sendes med (tilbage)fra klienten 
        {
            aktuelVare.Betegnelse = varedata.Betegnelse;
            aktuelVare.SalgsEnhedsPris = varedata.SalgsEnhedsPris;
        }
    }
}
