using System;
using System.Collections.Generic;
using System.Text;
using InterfaceLibrary;

namespace ModelLibrary
{
    public class Varekatalog : IVarekatalog
    {
        private List<Vare> vareListe = new List<Vare>();

        private object varekatalog_ls = new object();

        #region IVarekatalog Members

        public IVare OpretVare(int varenr, string betegnelse, float salgsEnhedsPris)
        {
            // precondition: der findes ikke andre vare med samme varenr
            Vare nyVare = new Vare(varenr, betegnelse, salgsEnhedsPris);
            lock (varekatalog_ls)
                vareListe.Add(nyVare);
            return nyVare;
        }

        public IVare[] GetAlleVarer()
        {
            lock (varekatalog_ls)
                return this.vareListe.ToArray() as IVare[];
        }

        public IVare FindVare(int varenr)
        {
            lock (varekatalog_ls)
            {
                foreach (IVare enVare in this.vareListe)
                {
                    if (enVare.Varenr == varenr)
                        return enVare;      // returner fundet
                }
            }
            return null;        // ikke fundet
        }

        #endregion
    }
}
