using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ModelLibrary;
using InterfaceLibrary;
using System.Runtime.Remoting;

namespace LocalWindowsApplication
{
    public partial class Form1 : Form
    {
        VareFacade vareFacade;

        VareDTO aktuelVareDTO;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnRegistrerRemoteVareFacade_Click(object sender, EventArgs e)
        {
            // Klientregistrering af et CAO vha. RegisterActivatedClientType(type, url)
            RemotingConfiguration.RegisterActivatedClientType(
                typeof(ModelLibrary.VareFacade),
                "http://localhost:65200");
            // Server-side instantiering vha. "new"
        }

        private void btnOpretVareFacade_Click(object sender, EventArgs e)
        {
            vareFacade = new VareFacade();
        }
        
        private void btnHentAlleVarer_Click(object sender, EventArgs e)
        {
            VareDTO[] varer = vareFacade.GetAlleVarerUdenBevgelser();
            dgwVarer.DataSource = varer;
        }

        private void dgwVarer_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if(dgwVarer.SelectedCells.Count > 0)
            {
                string svnr = dgwVarer.Rows[dgwVarer.SelectedCells[0].RowIndex].Cells[0].Value.ToString();  // varenr i kolonne 0
                int varenr = int.Parse(svnr);
                if (vareFacade.FindVare(varenr))
                {
                    aktuelVareDTO = vareFacade.GetAktuelVare();
                    this.tbxBetegnelse.Text = aktuelVareDTO.Betegnelse;
                    this.tbxSalgsEnhedsPris.Text = aktuelVareDTO.SalgsEnhedsPris.ToString("F2");

                    this.dgwBevgelser.DataSource = vareFacade.GetAktuelVarebevgelser();
                }
                else
                {
                    aktuelVareDTO = null;
                    dgwVarer.DataSource = null;
                }
            }
        }

        private void btnRetVaredata_Click(object sender, EventArgs e)
        {
            if (aktuelVareDTO == null)
                return;
            aktuelVareDTO.Betegnelse = this.tbxBetegnelse.Text;
            aktuelVareDTO.SalgsEnhedsPris = float.Parse(this.tbxSalgsEnhedsPris.Text);
            vareFacade.RetAktuelVare(aktuelVareDTO);
            // hent alle igen for kontrol
            VareDTO[] varer = vareFacade.GetAlleVarerUdenBevgelser();
            dgwVarer.DataSource = varer;
        }

        private void btnRegistrerKb_Click(object sender, EventArgs e)
        {
            if (aktuelVareDTO == null)
                return;
            vareFacade.RegistrerVarerIndkbtPAktuelVare(int.Parse(this.tbxAntal.Text));
            // hent alle igen for kontrol
            VareDTO[] varer = vareFacade.GetAlleVarerUdenBevgelser();
            this.dgwBevgelser.DataSource = vareFacade.GetAktuelVarebevgelser();
        }

        private void btnRegistrerSalg_Click(object sender, EventArgs e)
        {
            if (aktuelVareDTO == null)
                return;
            vareFacade.RegistrerVarerSolgtPAktuelVare(int.Parse(this.tbxAntal.Text));
            // hent alle igen for kontrol
            VareDTO[] varer = vareFacade.GetAlleVarerUdenBevgelser();
            this.dgwBevgelser.DataSource = vareFacade.GetAktuelVarebevgelser();
        }

    }
}